---
- name: "[Pre Upgrade Stage] Test PostgreSQL DB Access"
  command:
    "gitlab-psql -tAXc \"SELECT pg_is_in_recovery()\""
  register: recovery
  tags:
    - test-db-access
    - pre-upgrade
    - replica-check

- name: "[Pre Upgrade Stage] Verify host is a Patroni Replica"
  assert:
    that:
      - recovery.stdout == "t"
    success_msg: "Host is a Patroni Replica"
    fail_msg: "Host is not a Patroni Replica"
  tags:
    - pre-upgrade
    - replica-check

- name: "[Pre-Upgrade Stage] Disable chef-client"
  become: true
  become_user: root
  command: /usr/local/bin/chef-client-disable "Upgrade PostgreSQL to {{ pg_minor_version }}"
  tags:
    - stop-chef
    - pre-upgrade

- name: "[Pre-Upgrade Stage] Set Patroni tags to avoid failover - Step 1"
  lineinfile:
    path: "{{ patroni_config_file }}"
    regexp: '^tags: \{'
    line: 'tags:'
  tags:
    - pre-upgrade
    - patroni_ctl
    - add-patroni-tags

- name: "[Pre-Upgrade Stage] Set Patroni tags to avoid failover - Step 2"
  lineinfile:
    path: "{{ patroni_config_file }}"
    regexp: "{{ item.regexp }}"
    line: "{{ item.line }}"
    insertafter: '^tags:'
  loop:
    - { regexp: '^nofailover:', line: '  nofailover: true' }
    - { regexp: '^noloadbalance:', line: '  noloadbalance: true' }
  register: patroni_add_tags
  tags:
    - pre-upgrade
    - patroni_ctl
    - add-patroni-tags

- name: "[Pre-Upgrade Stage] Drain Traffic and Checkpoint"
  import_role:
    name: control_traffic
    tasks_from: close_access
  tags:
    - pre-upgrade
    - db-checkpoint
    - close-access
